unit Tri;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TDemoTri = class(TForm)
    Triage: TButton;
    Nombres: TListBox;
    Generation: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure GenerationClick(Sender: TObject);
    procedure TriageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  DemoTri: TDemoTri;

implementation

{$R *.dfm}

Var Les_Chiffres : array[0..1000000] of longint;

Procedure Tri_Nimportequoi;                    // ici des long
Var
   s, sj, sl, sr, j,S1: LongInt;        // les compteurs intermediaires  du tri
   Code: Longint;                       // Clef de recherche
   Resa_Chiffre: LongInt;               // Utiliser pour les permutation doit etre du mme type que la donnee trie
   St: Array[0..100, 0..1] Of LongInt;  // Table qui remplace la recursivit et amliore CONSIDERABLEMENT les performances
                                        // le dimensionnement  100 correspond au nombre maximal d'appel en recursivit
                                        // normalement 10 devraient suffir mais avec 100 on doit pouvoir trier quelque milliards d'infos...
Begin
     S := 1;                            // IMPORTANT je ne trie pas l'lment ZERO
     st[S, 0] := 1;                     // Il suffit normalement de metrre S  zero pour le trier
     st[S, 1] := 1000000;                 // Nombre d'elements  trier
     Repeat
       sl := st[S, 0];                  // Sauvegarde des offsets pour la recursivit
       sr := st[S, 1];
       S := pred(S);
       Repeat
         j := sl;                       // le quick sort trie le fichier par morceau de plus en plus grands
         sj := sr;
         S1 := (sl + sr) Div 2;            //  on divise le nombre d'elements choisi par deux
         Code := Les_Chiffres[S1];  // On mmorise le criter de tri de l'elemnt actif (plus de clarte dans les tests  suivre
         Repeat
           While (Les_Chiffres[J] < Code) Do   // Partant du debut de la portion selectionne on, recherche le p
             j := j + 1;                               // premier element plus grand dans cet interval
           While (Code < Les_Chiffres[Sj]) Do  // maintenant on recherchje le plus petit partant de la fin
             SJ := Sj - 1;
           If j <= sj Then                            // quand on a trouve on permute avec resa_Chiffre
            Begin                                     // l'autre concept du quick sort est que plus la  permutation est
              Resa_Chiffre := Les_Chiffres[Sj];       // lointaine plus elle est efficace: il vaut mieux permuter le premier
              Les_Chiffres[Sj] := Les_Chiffres[j];        // avec le dernier que le premier avec le second
              Les_Chiffres[j] := Resa_Chiffre;    // il a plus de chance d'tre  sa place
              j := Succ(J);                           // Je laisse les mathmaticiens le dmontrer....
              sj := Pred(sj);                         // on retrecie la portion de recherche jusqu'a son arrive  0 elements
            End;
         Until j > sj;
         If j < sr Then                               // Et c'est la qu'on recursive en se servant de la table
           Begin
             S := Succ(S);
             St[S, 0] := j;
             St[S, 1] := sr;
           End;
         sr := sj;
       until sl >= sr;
     Until S < 1;
End;                                                  // et la c'est FINI

procedure TDemoTri.GenerationClick(Sender: TObject);
var i : longint;
begin
  Randomize;
  Label2.Caption := '0';
  for i:= 1 to 1000000 do
    Les_Chiffres[i]:=Random(5000000);
  Nombres.Clear;
  for i:=1 to 500 do
    Nombres.Items.Add(IntToStr(Les_Chiffres[i]))


end;

procedure TDemoTri.TriageClick(Sender: TObject);
Var i:integer;
    TempsLecture:longWord;
begin
  TempsLecture:=GetTickCount;
  Tri_Nimportequoi;
  TempsLecture:=GetTickCount-TempsLecture;
  Label2.Caption := IntToStr(TempsLecture);
  Nombres.Clear;
  for i:=1 to 500 do
    Nombres.Items.Add(IntToStr(Les_Chiffres[i]));
end;

procedure TDemoTri.FormCreate(Sender: TObject);
begin
  GenerationClick(self);
end;

end.
